Index: chan_zap.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_zap.c,v
retrieving revision 1.527
diff -u -r1.527 chan_zap.c
--- chan_zap.c	28 Sep 2005 23:10:14 -0000	1.527
+++ chan_zap.c	29 Sep 2005 17:11:36 -0000
@@ -2087,6 +2087,32 @@
 				pridialplan = PRI_LOCAL_ISDN;
  			}
  		}
+
+		/* override specified pri dialplan or dynamic pri dialplan
+		   if explicitly defined in the dailed string */
+		switch (*(c + p->stripmsd)) {
+			case 'i':
+				pridialplan = PRI_INTERNATIONAL_ISDN;
+				++c;
+				break;
+			case 'n':
+				pridialplan = PRI_NATIONAL_ISDN;
+				++c;
+				break;
+			case 'l':
+				pridialplan = PRI_LOCAL_ISDN;
+				++c;
+				break;
+			case 'u':
+				pridialplan = PRI_UNKNOWN;
+				++c;
+				break;
+			case 'p':
+				pridialplan = PRI_PRIVATE;
+				++c;
+				break;
+		}
+
  		pri_sr_set_called(sr, c + p->stripmsd + dp_strip, pridialplan,  s ? 1 : 0);
 
 		ldp_strip = 0;
@@ -2102,6 +2128,34 @@
 				prilocaldialplan = PRI_LOCAL_ISDN;
 			}
 		}
+
+		/* override specified pri local dialplan or dynamic pri local
+		   dialplan if explicitly defined in the callerID number */
+		if (l != NULL) {
+			switch (*l) {
+				case 'i':
+					prilocaldialplan = PRI_INTERNATIONAL_ISDN;
+					++l;
+					break;
+				case 'n':
+					prilocaldialplan = PRI_NATIONAL_ISDN;
+					++l;
+					break;
+				case 'l':
+					prilocaldialplan = PRI_LOCAL_ISDN;
+					++l;
+					break;
+				case 'u':
+					prilocaldialplan = PRI_UNKNOWN;
+					++l;
+					break;
+				case 'p':
+					prilocaldialplan = PRI_PRIVATE;
+					++l;
+					break;
+			}
+		}
+
 		pri_sr_set_caller(sr, l ? (l + ldp_strip) : NULL, n, prilocaldialplan, 
 					l ? (p->use_callingpres ? ast->cid.cid_pres : PRES_ALLOWED_USER_NUMBER_PASSED_SCREEN) : 
 						 PRES_NUMBER_NOT_AVAILABLE);
